SHARED CONST TRUE = -1
SHARED CONST FALSE = 0
SHARED CONST R0 = 2
SHARED CONST R0L = 2
SHARED CONST R0H = 3
SHARED CONST R1 = 4
SHARED CONST R1L = 4
SHARED CONST R1H = 5
SHARED CONST R2 = 6
SHARED CONST R2L = 6
SHARED CONST R2H = 7
SHARED CONST R3 = 8
SHARED CONST R3L = 8
SHARED CONST R3H = 9
SHARED CONST R4 = $0A
SHARED CONST R4L = $0A
SHARED CONST R4H = $0B
SHARED CONST R5 = $0C
SHARED CONST R5L = $0C
SHARED CONST R5H = $0D
SHARED CONST R6 = $0E
SHARED CONST R6L = $0F
SHARED CONST R7 = $10
SHARED CONST R7L = $10
SHARED CONST R7H = $11
SHARED CONST R8 = $12
SHARED CONST R8L = $12
SHARED CONST R8H = $13
SHARED CONST R9 = $14
SHARED CONST R9L = $14
SHARED CONST R9H = $15
SHARED CONST R10 = $16
SHARED CONST R10L = $16
SHARED CONST R10H = $17
SHARED CONST R11 = $18
SHARED CONST R11L = $18
SHARED CONST R11H = $19
SHARED CONST R12 = $1A
SHARED CONST R12L = $1A
SHARED CONST R12H = $1B
SHARED CONST R13 = $1C
SHARED CONST R13L = $1C
SHARED CONST R13H = $1D
SHARED CONST R14 = $1E
SHARED CONST R14L = $1E
SHARED CONST R14H = $1F
SHARED CONST R15 = $20
SHARED CONST R15L = $20
SHARED CONST R15H = $20 
SHARED CONST MACPTR = $FF44
SHARED CONST MCIOUT = $FEB1
SHARED CONST CHKIN = $FFC6
SHARED CONST CHKOUT = $FFC9
SHARED CONST CLRCHN = $FFCC
SHARED CONST CHROUT = $FFD2
SHARED CONST CHRIN = $FFCF
SHARED CONST READST = $FFB7
SHARED CONST RDTIM = $FFDE
SHARED CONST SETTIM = $FFDB
SHARED CONST MEM_COPY = $FEE7

DIM L AS BYTE FAST
DIM I AS BYTE FAST
DIM II AS INT
DIM C AS BYTE FAST
DIM CS AS STRING * 1
DIM SHARED FC AS STRING * 3
DIM SHARED FMSG AS STRING * 40
DIM SHARED E1 AS STRING * 2
DIM SHARED E2 AS STRING * 2



FUNCTION SIGNED_BYTE AS INT(TByte AS BYTE) STATIC SHARED
  DIM TMPInt AS INT
  TMPInt = TByte
  IF TByte > 127 THEN TMPInt = TMPInt-256
  RETURN TMPInt
END FUNCTION

FUNCTION ASCII_UPPER AS STRING*96(TARGET AS STRING*96) STATIC SHARED
 DIM TMPStr AS STRING*96
 TMPStr = ""
 L = LEN(TARGET)-1
 FOR I = 0 TO L
     C=ASC(MID$(TARGET,I,1))
     IF C > 96 AND C < 123 THEN C=C-32
     IF C > 192 AND C < 219 THEN C=C-128
     TMPStr=TmpStr + CHR$(C)
 NEXT I
 RETURN TMPStr
END FUNCTION

FUNCTION FILEEXISTS AS BYTE(FName AS STRING * 96,DEVICE AS BYTE) STATIC SHARED
  OPEN 2,DEVICE,2,FName + ",s,r"
  CLOSE 2
  OPEN 15,DEVICE,15
  INPUT #15, FC,FMSG,E1,E2
  CLOSE 15
  RETURN VAL(FC) < 20
END FUNCTION

FUNCTION FILE_EXTENSION AS STRING * 10(Name AS STRING*96) STATIC SHARED
  DIM TMPStrE AS STRING * 10
  DIM GotIt AS BYTE
  TMPStrE = ""
  L=LEN(Name)-1
  GotIt = 0
  FOR II = L TO 0 STEP -1
       CS = MID$(Name,CByte(II),1)
       IF CS = "." THEN
         GotIt=$FF
         EXIT FOR
       END IF
       TMPStrE = CS + TmpStrE
  NEXT II
  IF NOT GotIt THEN TmpStrE = ""
  RETURN TmpStrE
END FUNCTION


FUNCTION READTIM AS LONG() STATIC SHARED
 DIM TMP AS LONG
 ASM
   jsr {RDTIM}
   sta {TMP}
   stx {TMP}+1
   sty {TMP}+2
 END ASM
 RETURN TMP
END FUNCTION

SUB ZeroTimer() STATIC SHARED
  ASM
   lda #0
   tax
   tay
   jsr {SETTIM}
 END ASM
END SUB



